Index: trunk/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1314)
+++ trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1321)
@@ -35,5 +35,4 @@
     \brief    decoder class
 */
-
 #include "NALread.h"
 #include "TDecTop.h"
@@ -127,7 +126,4 @@
   }
 }
-
-
-
 
 Void
@@ -290,19 +286,4 @@
 }
 
-
-#if !NH_3D_FIX_TICKET_101
-#if NH_3D_IV_MERGE
-Void
-CamParsCollector::copyCamParamForSlice( TComSlice* pcSlice )
-{
-  if( m_bCamParsVaryOverTime )
-  {
-    pcSlice->setCamparaSlice( m_aaiCodedScale, m_aaiCodedOffset );
-  }
-}
-#endif
-#endif
-
-
 Void
 CamParsCollector::xOutput( Int iPOC )
@@ -351,9 +332,9 @@
 TDecTop::TDecTop()
   : m_iMaxRefPicNum(0)
+#if !NH_MV
   , m_associatedIRAPType(NAL_UNIT_INVALID)
-  , m_pocCRA(0)
+  , m_pocCRA(0)  
   , m_pocRandomAccess(MAX_INT)
   , m_cListPic()
-#if !NH_MV
   , m_parameterSetManager()
 #endif
@@ -373,4 +354,5 @@
   , m_cSAO()
   , m_pcPic(NULL)
+#if !NH_MV
   , m_prevPOC(MAX_INT)
   , m_prevTid0POC(0)
@@ -383,56 +365,66 @@
   , m_isNoOutputPriorPics(false)
   , m_craNoRaslOutputFlag(false)
+#endif
 #if O0043_BEST_EFFORT_DECODING
   , m_forceDecodeBitDepth(8)
 #endif
   , m_pDecodedSEIOutputStream(NULL)
+#if !NH_MV
   , m_warningMessageSkipPicture(false)
+#endif
   , m_prefixSEINALUs()
+{
+#if !NH_MV
+#if ENC_DEC_TRACE
+  if (g_hTrace == NULL)
+  {
+    g_hTrace = fopen( "TraceDec.txt", "wb" );
+  }
+  g_bJustDoIt = g_bEncDecTraceDisable;
+  g_nSymbolCounter = 0;
+#endif
+#endif
+
+#if NH_MV
+  m_layerId                       = 0;
+  m_viewId                        = 0;
+
+#if NH_3D
+  m_viewIndex                     = 0;
+  m_isDepth                       = false;
+  m_pcCamParsCollector            = 0;
+#endif
+
+  m_decodingProcess               = CLAUSE_8;
+  m_targetOlsIdx                  = -1;
+  m_smallestLayerId               = -1;
+  m_isInOwnTargetDecLayerIdList   = 0;
+  m_prevPicOrderCnt               = 0;
+  m_pocDecrementedInDpbFlag       = NULL;
+  m_firstPicInLayerDecodedFlag    = NULL;
+  m_lastPresentPocResetIdc        = NULL;
+
+  m_prevIrapPoc                   = MIN_INT;
+  m_prevIrapDecodingOrder         = MIN_INT;
+  m_prevStsaDecOrder              = MIN_INT;
+  m_prevStsaTemporalId            = MIN_INT;
+#endif
+}
+
+TDecTop::~TDecTop()
 {
 #if ENC_DEC_TRACE
 #if NH_MV
-  if ( g_hTrace == NULL )
-  {
-#endif
-  if (g_hTrace == NULL)
-  {
-    g_hTrace = fopen( "TraceDec.txt", "wb" );
-  }
-  g_bJustDoIt = g_bEncDecTraceDisable;
-  g_nSymbolCounter = 0;
-#if NH_MV
-  }
-#endif
-#endif
-#if NH_MV
-  m_isLastNALWasEos = false;
-  m_layerId = 0;
-  m_viewId = 0;
-#if NH_3D
-  m_viewIndex = 0; 
-  m_isDepth = false;
-  m_pcCamParsCollector = 0;
-#endif
-#if NH_MV
-  m_targetOlsIdx = -1; 
-#endif
-#endif
-
-}
-
-TDecTop::~TDecTop()
-{
-#if ENC_DEC_TRACE
-#if H_MV_ENC_DEC_TRAC_FIX
   if (g_hTrace != stdout && g_hTrace != NULL)
+  {
+    fclose( g_hTrace );
+    g_hTrace = NULL;
+  }
 #else
   if (g_hTrace != stdout)
-#endif
   {
     fclose( g_hTrace );
-#if H_MV_ENC_DEC_TRAC_FIX
-    g_hTrace = NULL;
-#endif
-  }
+  }
+#endif  
 #endif
   while (!m_prefixSEINALUs.empty())
@@ -452,4 +444,10 @@
 Void TDecTop::destroy()
 {
+
+#if NH_MV
+  m_cSAO.destroy();
+  m_cLoopFilter.        destroy();
+#endif
+
   m_cGopDecoder.destroy();
 
@@ -474,6 +472,8 @@
 }
 
+#if !NH_MV
 Void TDecTop::deletePicBuffer ( )
 {
+
   TComList<TComPic*>::iterator  iterPic   = m_cListPic.begin();
   Int iSize = Int( m_cListPic.size() );
@@ -482,15 +482,8 @@
   {
     TComPic* pcPic = *(iterPic++);
-#if NH_MV
-    if( pcPic )
-    {
-#endif
     pcPic->destroy();
 
     delete pcPic;
     pcPic = NULL;
-#if NH_MV
-    }
-#endif
   }
 
@@ -499,33 +492,11 @@
   m_cLoopFilter.        destroy();
 
-#if !NH_MV
   // destroy ROM
   destroyROM();
-#endif
 }
 
 Void TDecTop::xGetNewPicBuffer ( const TComSPS &sps, const TComPPS &pps, TComPic*& rpcPic, const UInt temporalLayer )
 {
-#if NH_MV
-  if ( getLayerId() == 0 )
-  {  
-    m_iMaxRefPicNum = sps.getMaxDecPicBuffering(temporalLayer);     // m_uiMaxDecPicBuffering has the space for the picture currently being decoded
-  }
-  else
-  {
-    //GTCIC
-    //m_iMaxRefPicNum = pcSlice->getVPS()->getMaxDecPicBuffering(pcSlice->getTLayer());    
-#if H_MV_HLS7_GEN 
-    TComVPS* vps         = pcSlice->getVPS();
-    TComDpbSize* dpbSize = vps->getDpbSize(); 
-    Int lsIdx            = vps->olsIdxToLsIdx( getTargetOutputLayerSetIdx()); // Is this correct, seems to be missing in spec?
-    Int layerIdx         = vps->getIdxInLayerSet     ( lsIdx, getLayerId() ); 
-    Int subDpbIdx        = dpbSize->getSubDpbAssigned( lsIdx, layerIdx ); 
-    m_iMaxRefPicNum      = dpbSize->getMaxVpsDecPicBufferingMinus1(getTargetOutputLayerSetIdx(), subDpbIdx , vps->getSubLayersVpsMaxMinus1( vps->getLayerIdInVps( getLayerId() ) ) + 1 ) + 1 ;  
-#endif    
-  }
-#else
   m_iMaxRefPicNum = sps.getMaxDecPicBuffering(temporalLayer);     // m_uiMaxDecPicBuffering has the space for the picture currently being decoded
-#endif
   if (m_cListPic.size() < (UInt)m_iMaxRefPicNum)
   {
@@ -547,7 +518,4 @@
     {
       rpcPic->setOutputMark(false);
-#if NH_MV
-      rpcPic->setPicOutputFlag(false); 
-#endif
       bBufferIsAvailable = true;
       break;
@@ -557,7 +525,4 @@
     {
       rpcPic->setOutputMark(false);
-#if NH_MV
-      rpcPic->setPicOutputFlag(false); 
-#endif
       rpcPic->setReconMark( false );
       rpcPic->getPicYuvRec()->setBorderExtension( false );
@@ -577,9 +542,6 @@
   rpcPic->create ( sps, pps, true);
 }
-#if NH_MV
-Void TDecTop::endPicDecoding(Int& poc, TComList<TComPic*>*& rpcListPic, std::vector<Int>& targetDecLayerIdSet )
-#else
+
 Void TDecTop::executeLoopFilters(Int& poc, TComList<TComPic*>*& rpcListPic)
-#endif
 {
   if (!m_pcPic)
@@ -599,10 +561,5 @@
   rpcListPic          = &m_cListPic;
   m_cCuDecoder.destroy();
-#if NH_MV 
-  TComSlice::markIvRefPicsAsShortTerm( m_refPicSetInterLayer0, m_refPicSetInterLayer1 );  
-  TComSlice::markCurrPic( pcPic ); 
-#endif
   m_bFirstSliceInPicture  = true;
-
   return;
 }
@@ -623,7 +580,4 @@
     {
       pcPicTmp->setOutputMark(false);
-#if NH_MV
-      pcPicTmp->setPicOutputFlag(false); 
-#endif
     }
   }
@@ -673,10 +627,20 @@
   }
 }
-
-
+#endif
+
+
+#if NH_MV
+Void TDecTop::activatePSsAndInitPicOrSlice( TComPic* newPic )
+{
+  if ( m_apcSlicePilot->getFirstSliceSegementInPicFlag() )
+  {
+    assert( newPic != NULL );
+
+#else
 Void TDecTop::xActivateParameterSets()
 {
   if (m_bFirstSliceInPicture)
   {
+#endif
     const TComPPS *pps = m_parameterSetManager.getPPS(m_apcSlicePilot->getPPSId()); // this is a temporary PPS object. Do not store this value
     assert (pps != 0);
@@ -690,5 +654,6 @@
     const TComVPS* vps = m_parameterSetManager.getVPS(sps->getVPSId());
     assert (vps != 0); 
-    if (!m_parameterSetManager.activatePPS(m_apcSlicePilot->getPPSId(),m_apcSlicePilot->isIRAP(), m_layerId ) )
+    // TBD: check the condition on m_firstPicInLayerDecodedFlag 
+    if (!m_parameterSetManager.activatePPS(m_apcSlicePilot->getPPSId(),m_apcSlicePilot->isIRAP() || !m_firstPicInLayerDecodedFlag[m_layerId] , m_layerId ) )
 #else
     if (false == m_parameterSetManager.activatePPS(m_apcSlicePilot->getPPSId(),m_apcSlicePilot->isIRAP()))
@@ -700,20 +665,23 @@
 
 #if NH_MV
-  // When the value of vps_num_rep_formats_minus1 in the active VPS is equal to 0
-  if ( vps->getVpsNumRepFormatsMinus1() == 0 )
-  {
-    //, it is a requirement of bitstream conformance that the value of update_rep_format_flag shall be equal to 0.
-    assert( sps->getUpdateRepFormatFlag() == false ); 
-  }
-  sps->checkRpsMaxNumPics( vps, getLayerId() ); 
-
-  // It is a requirement of bitstream conformance that, when the SPS is referred to by 
-  // any current picture that belongs to an independent non-base layer, the value of 
-  // MultiLayerExtSpsFlag derived from the SPS shall be equal to 0.
-
-  if ( m_layerId > 0 && vps->getNumRefLayers( m_layerId ) == 0 )
-  {  
-    assert( sps->getMultiLayerExtSpsFlag() == 0 ); 
-  }
+    if ( decProcAnnexG() )
+    {
+      // When the value of vps_num_rep_formats_minus1 in the active VPS is equal to 0
+      if ( vps->getVpsNumRepFormatsMinus1() == 0 )
+      {
+        //, it is a requirement of bitstream conformance that the value of update_rep_format_flag shall be equal to 0.
+        assert( sps->getUpdateRepFormatFlag() == false ); 
+      }
+      sps->checkRpsMaxNumPics( vps, getLayerId() ); 
+
+      // It is a requirement of bitstream conformance that, when the SPS is referred to by 
+      // any current picture that belongs to an independent non-base layer, the value of 
+      // MultiLayerExtSpsFlag derived from the SPS shall be equal to 0.
+
+      if ( m_layerId > 0 && vps->getNumRefLayers( m_layerId ) == 0 )
+      {  
+        assert( sps->getMultiLayerExtSpsFlag() == 0 ); 
+      }
+    }
 #endif
 
@@ -734,8 +702,10 @@
 
     //  Get a new picture buffer. This will also set up m_pcPic, and therefore give us a SPS and PPS pointer that we can use.
+#if !NH_MV
     xGetNewPicBuffer (*(sps), *(pps), m_pcPic, m_apcSlicePilot->getTLayer());
+
     m_apcSlicePilot->applyReferencePictureSet(m_cListPic, m_apcSlicePilot->getRPS());
-#if NH_MV
-    m_apcSlicePilot->createInterLayerReferencePictureSet( m_ivPicLists, m_refPicSetInterLayer0, m_refPicSetInterLayer1 ); 
+#else
+    m_pcPic = newPic; 
 #endif
 
@@ -752,4 +722,5 @@
 
 #if NH_MV
+    pSlice->setPic( m_pcPic );
     vps=pSlice->getVPS();  
     // The nuh_layer_id value of the NAL unit containing the PPS that is activated for a layer layerA with nuh_layer_id equal to nuhLayerIdA shall be equal to 0, or nuhLayerIdA, or the nuh_layer_id of a direct or indirect reference layer of layerA.
@@ -803,4 +774,8 @@
   else
   {
+#if NH_MV
+    assert( m_pcPic != NULL ); 
+    assert( newPic  == NULL ); 
+#endif
     // make the slice-pilot a real slice, and set up the slice-pilot for the next slice
     m_pcPic->allocateNewSlice();
@@ -828,14 +803,15 @@
 
     // Check if any new SEI has arrived
-     if(!m_SEIs.empty())
-     {
-       // Currently only decoding Unit SEI message occurring between VCL NALUs copied
-       SEIMessages &picSEI = m_pcPic->getSEIs();
-       SEIMessages decodingUnitInfos = extractSeisByType (m_SEIs, SEI::DECODING_UNIT_INFO);
-       picSEI.insert(picSEI.end(), decodingUnitInfos.begin(), decodingUnitInfos.end());
-       deleteSEIs(m_SEIs);
-     }
-  }
-}
+    if(!m_SEIs.empty())
+    {
+      // Currently only decoding Unit SEI message occurring between VCL NALUs copied
+      SEIMessages &picSEI = m_pcPic->getSEIs();
+      SEIMessages decodingUnitInfos = extractSeisByType (m_SEIs, SEI::DECODING_UNIT_INFO);
+      picSEI.insert(picSEI.end(), decodingUnitInfos.begin(), decodingUnitInfos.end());
+      deleteSEIs(m_SEIs);
+    }
+  }
+}
+
 Void TDecTop::xParsePrefixSEIsForUnknownVCLNal()
 {
@@ -865,18 +841,26 @@
 }
 
-
-#if NH_MV
-Bool TDecTop::xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay, Bool newLayerFlag, Bool& sliceSkippedFlag  )
-{
-  assert( nalu.m_nuhLayerId == m_layerId ); 
+#if !NH_MV
+Bool TDecTop::xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay )
+{
+  m_apcSlicePilot->initSlice(); // the slice pilot is an object to prepare for a new slice
+  // it is not associated with picture, sps or pps structures.
+  if (m_bFirstSliceInPicture)
+  {
 #else
-Bool TDecTop::xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay )
-{
-#endif
+Void TDecTop::decodeSliceHeader(InputNALUnit &nalu )
+{
+  // Initialize entropy decoder
+  m_cEntropyDecoder.setEntropyDecoder (&m_cCavlcDecoder);
+  m_cEntropyDecoder.setBitstream      (&(nalu.getBitstream()));
+
+  assert( nalu.m_nuhLayerId == m_layerId );   
   m_apcSlicePilot->initSlice(); // the slice pilot is an object to prepare for a new slice
-                                // it is not associated with picture, sps or pps structures.
-
-  if (m_bFirstSliceInPicture)
-  {
+  // it is not associated with picture, sps or pps structures.
+  m_apcSlicePilot->setLayerId( nalu.m_nuhLayerId ); 
+  m_cEntropyDecoder.decodeFirstSliceSegmentInPicFlag( m_apcSlicePilot );   
+  if ( m_apcSlicePilot->getFirstSliceSegementInPicFlag() )
+  {
+#endif  
     m_uiSliceIdx = 0;
   }
@@ -889,23 +873,25 @@
   m_apcSlicePilot->setNalUnitType(nalu.m_nalUnitType);
   Bool nonReferenceFlag = (m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_TRAIL_N ||
-                           m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_TSA_N   ||
-                           m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_STSA_N  ||
-                           m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_RADL_N  ||
-                           m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_RASL_N);
+    m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_TSA_N   ||
+    m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_STSA_N  ||
+    m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_RADL_N  ||
+    m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_RASL_N);
   m_apcSlicePilot->setTemporalLayerNonReferenceFlag(nonReferenceFlag);
+#if !NH_MV
   m_apcSlicePilot->setReferenced(true); // Putting this as true ensures that picture is referenced the first time it is in an RPS
+#endif
   m_apcSlicePilot->setTLayerInfo(nalu.m_temporalId);
-
+#if NH_MV
+  m_cEntropyDecoder.decodeSliceHeader (m_apcSlicePilot, &m_parameterSetManager );
+#else
 #if ENC_DEC_TRACE
   const UInt64 originalSymbolCount = g_nSymbolCounter;
 #endif
+    m_cEntropyDecoder.decodeSliceHeader (m_apcSlicePilot, &m_parameterSetManager, m_prevTid0POC);
+#endif
 
 #if NH_MV
-  m_apcSlicePilot->setRefPicSetInterLayer( & m_refPicSetInterLayer0, &m_refPicSetInterLayer1 ); 
-  m_apcSlicePilot->setLayerId( nalu.m_nuhLayerId );
-#endif
-
-  m_cEntropyDecoder.decodeSliceHeader (m_apcSlicePilot, &m_parameterSetManager, m_prevTid0POC);
-
+}
+#else
   // set POC for dependent slices in skipped pictures
   if(m_apcSlicePilot->getDependentSliceSegmentFlag() && m_prevSliceSkipped)
@@ -915,27 +901,17 @@
 
   xUpdatePreviousTid0POC(m_apcSlicePilot);
-
   m_apcSlicePilot->setAssociatedIRAPPOC(m_pocCRA);
   m_apcSlicePilot->setAssociatedIRAPType(m_associatedIRAPType);
-#if NH_MV  
-  const TComVPS* vps     = m_apcSlicePilot->getVPS();
-  Int layerId            = nalu.m_nuhLayerId;   
-  setViewId   ( vps->getViewId   ( layerId )      );  
-#if NH_3D
-  setViewIndex( vps->getViewIndex( layerId )      );  
-  setIsDepth  ( vps->getDepthId  ( layerId ) == 1 );  
-  m_ivPicLists->setVPS( vps ); 
-#endif
-#endif
+
 
   //For inference of NoOutputOfPriorPicsFlag
   if (m_apcSlicePilot->getRapPicFlag())
   {
-    if ((m_apcSlicePilot->getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP && m_apcSlicePilot->getNalUnitType() <= NAL_UNIT_CODED_SLICE_IDR_N_LP) || 
+      if ((m_apcSlicePilot->getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP && m_apcSlicePilot->getNalUnitType() <= NAL_UNIT_CODED_SLICE_IDR_N_LP) || 
         (m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA && m_bFirstSliceInSequence) ||
         (m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA && m_apcSlicePilot->getHandleCraAsBlaFlag()))
-    {
-      m_apcSlicePilot->setNoRaslOutputFlag(true);
-    }
+      {
+        m_apcSlicePilot->setNoRaslOutputFlag(true);
+      }
     //the inference for NoOutputPriorPicsFlag
     if (!m_bFirstSliceInBitstream && m_apcSlicePilot->getRapPicFlag() && m_apcSlicePilot->getNoRaslOutputFlag())
@@ -948,5 +924,5 @@
     else
     {
-      m_apcSlicePilot->setNoOutputPriorPicsFlag(false);
+      m_apcSlicePilot->setNoOutputPriorPicsFlag(false); 
     }
 
@@ -974,5 +950,5 @@
     }
   }
-
+  
   if (m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA && m_craNoRaslOutputFlag) //Reset POC MSB when CRA has NoRaslOutputFlag equal to 1
   {
@@ -985,21 +961,10 @@
     xUpdatePreviousTid0POC(m_apcSlicePilot);
   }
-#if NH_MV
-    xCeckNoClrasOutput();
-#endif
 
   // Skip pictures due to random access
-
-#if NH_MV
-  if (isRandomAccessSkipPicture(iSkipFrame, iPOCLastDisplay, vps))
-#else
   if (isRandomAccessSkipPicture(iSkipFrame, iPOCLastDisplay))
-#endif
   {
     m_prevSliceSkipped = true;
     m_skippedPOC = m_apcSlicePilot->getPOC();
-#if NH_MV
-    sliceSkippedFlag = true; 
-#endif
     return false;
   }
@@ -1009,7 +974,4 @@
     m_prevSliceSkipped = true;
     m_skippedPOC = m_apcSlicePilot->getPOC();
-#if NH_MV
-    sliceSkippedFlag = true; 
-#endif
     return false;
   }
@@ -1030,4 +992,5 @@
     {
       m_prevPOC = m_apcSlicePilot->getPOC();
+
 #if ENC_DEC_TRACE
       //rewind the trace counter since we didn't actually decode the slice
@@ -1038,45 +1001,4 @@
     m_prevPOC = m_apcSlicePilot->getPOC();
   }
-#if NH_MV
-  if ( newLayerFlag )
-  {
-    return false; 
-  }
-#if ENC_DEC_TRACE
-#if H_MV_ENC_DEC_TRAC
-  // parse remainder of SH
-   g_disableHLSTrace = false; 
-#endif
-#endif
-#endif
-
-#if NH_MV
-   // This part needs further testing !
-   if ( m_apcSlicePilot->getPocResetFlag() )
-   {   
-     xResetPocInPicBuffer();
-   }
-
-   if ( m_apcSlicePilot->getTLayer() == 0 && m_apcSlicePilot->getEnableTMVPFlag() == 0 )
-  {
-    //update all pics in the DPB such that they cannot be used for TMPV ref
-    TComList<TComPic*>::iterator  iterRefPic = m_cListPic.begin();  
-    while( iterRefPic != m_cListPic.end() )
-    {
-      TComPic *refPic = *iterRefPic;
-      if( ( refPic->getLayerId() == m_apcSlicePilot->getLayerId() ) && refPic->getReconMark() )
-      {
-        for(Int i = refPic->getNumAllocatedSlice()-1; i >= 0; i--)
-        {
-
-          TComSlice *refSlice = refPic->getSlice(i);
-          refSlice->setAvailableForTMVPRefFlag( false );
-        }
-      }
-      iterRefPic++;
-    }
-  }
-  m_apcSlicePilot->setAvailableForTMVPRefFlag( true );
-#endif
 
   //detect lost reference picture and insert copy of earlier frame.
@@ -1093,5 +1015,4 @@
     m_prevPOC = m_apcSlicePilot->getPOC();
   }
-
   // actual decoding starts here
   xActivateParameterSets();
@@ -1103,187 +1024,197 @@
   TComSlice* pcSlice = m_pcPic->getPicSym()->getSlice(m_uiSliceIdx);
 
-  // When decoding the slice header, the stored start and end addresses were actually RS addresses, not TS addresses.
-  // Now, having set up the maps, convert them to the correct form.
-  pcSlice->setSliceSegmentCurStartCtuTsAddr( m_pcPic->getPicSym()->getCtuRsToTsAddrMap(pcSlice->getSliceSegmentCurStartCtuTsAddr()) );
-  pcSlice->setSliceSegmentCurEndCtuTsAddr( m_pcPic->getPicSym()->getCtuRsToTsAddrMap(pcSlice->getSliceSegmentCurEndCtuTsAddr()) );
-  if(!pcSlice->getDependentSliceSegmentFlag())
-  {
-    pcSlice->setSliceCurStartCtuTsAddr(m_pcPic->getPicSym()->getCtuRsToTsAddrMap(pcSlice->getSliceCurStartCtuTsAddr()));
-    pcSlice->setSliceCurEndCtuTsAddr(m_pcPic->getPicSym()->getCtuRsToTsAddrMap(pcSlice->getSliceCurEndCtuTsAddr()));
-  }
-
-  m_pcPic->setTLayer(nalu.m_temporalId);
+#endif
 
 #if NH_MV
-  //Check Multiview Main profile constraint in G.11.1.1
-  //  When ViewOrderIdx[ i ] derived according to any active VPS is equal to 1 
-  //  for the layer with nuh_layer_id equal to i in subBitstream, 
-  //  inter_view_mv_vert_constraint_flag shall be equal to 1 
-  //  in the sps_multilayer_extension( ) syntax structure in each active SPS for that layer.
-  if( pcSlice->getSPS()->getPTL()->getGeneralPTL()->getProfileIdc()==Profile::MULTIVIEWMAIN
+Void TDecTop::decodeSliceSegment(InputNALUnit &nalu )
+{
+  TComSlice* pcSlice = m_pcPic->getPicSym()->getSlice(m_uiSliceIdx);
+
+  if ( m_pcPic->getHasGeneratedRefPics() )
+  {
+    if ( pcSlice->getFirstSliceSegementInPicFlag() )
+    {
+      std::cout << std:: setfill(' ')
+        << "Layer "  << std::setw(2) << m_pcPic->getLayerId()
+        << "   POC " << std::setw(4) << m_pcPic->getPOC()
+        << " Reference pictures missing. Skipping picture." << std::endl;
+    }
+  }
+  else
+  {
+    //Check Multiview Main profile constraint in G.11.1.1
+    //  When ViewOrderIdx[ i ] derived according to any active VPS is equal to 1 
+    //  for the layer with nuh_layer_id equal to i in subBitstream, 
+    //  inter_view_mv_vert_constraint_flag shall be equal to 1 
+    //  in the sps_multilayer_extension( ) syntax structure in each active SPS for that layer.
+    if( pcSlice->getSPS()->getPTL()->getGeneralPTL()->getProfileIdc()==Profile::MULTIVIEWMAIN
       &&
       pcSlice->getVPS()->getViewOrderIdx(pcSlice->getVPS()->getLayerIdInNuh(getLayerId()))==1 
-     )
-  {
-    assert( pcSlice->getSPS()->getInterViewMvVertConstraintFlag()==1 );
-  }
-#endif
-#if NH_MV
-  m_pcPic->setLayerId( nalu.m_nuhLayerId );
-  m_pcPic->setViewId ( getViewId() );
+      )
+    {
+      assert( pcSlice->getSPS()->getInterViewMvVertConstraintFlag()==1 );
+    }
+
+    m_pcPic->setLayerId( nalu.m_nuhLayerId );
+    m_pcPic->setViewId ( getViewId() );
 #if NH_3D
-  m_pcPic->setViewIndex( getViewIndex() );
-  m_pcPic->setIsDepth  ( getIsDepth  () );
-  pcSlice->setIvPicLists( m_ivPicLists );         
-#endif
-#endif
-
-  if (!pcSlice->getDependentSliceSegmentFlag())
-  {
-    pcSlice->checkCRA(pcSlice->getRPS(), m_pocCRA, m_associatedIRAPType, m_cListPic );
-    // Set reference list
-#if NH_MV    
-    std::vector< TComPic* > tempRefPicLists[2];
-    std::vector< Bool     > usedAsLongTerm [2];
-    Int       numPocTotalCurr;
-
-    pcSlice->getTempRefPicLists( m_cListPic, m_refPicSetInterLayer0, m_refPicSetInterLayer1, tempRefPicLists, usedAsLongTerm, numPocTotalCurr);
-    pcSlice->setRefPicList     ( tempRefPicLists, usedAsLongTerm, numPocTotalCurr, true ); 
+    m_pcPic->setViewIndex( getViewIndex() );
+    m_pcPic->setIsDepth  ( getIsDepth  () );
+    pcSlice->setIvPicLists( m_dpb );         
+#endif
+#endif
+    
+    // When decoding the slice header, the stored start and end addresses were actually RS addresses, not TS addresses.
+    // Now, having set up the maps, convert them to the correct form.
+    pcSlice->setSliceSegmentCurStartCtuTsAddr( m_pcPic->getPicSym()->getCtuRsToTsAddrMap(pcSlice->getSliceSegmentCurStartCtuTsAddr()) );
+    pcSlice->setSliceSegmentCurEndCtuTsAddr( m_pcPic->getPicSym()->getCtuRsToTsAddrMap(pcSlice->getSliceSegmentCurEndCtuTsAddr()) );
+    if(!pcSlice->getDependentSliceSegmentFlag())
+    {
+      pcSlice->setSliceCurStartCtuTsAddr(m_pcPic->getPicSym()->getCtuRsToTsAddrMap(pcSlice->getSliceCurStartCtuTsAddr()));
+      pcSlice->setSliceCurEndCtuTsAddr(m_pcPic->getPicSym()->getCtuRsToTsAddrMap(pcSlice->getSliceCurEndCtuTsAddr()));
+    }
+
+    m_pcPic->setTLayer(nalu.m_temporalId);
+
+
+    if (!pcSlice->getDependentSliceSegmentFlag())
+    {
+#if !NH_MV
+      pcSlice->checkCRA(pcSlice->getRPS(), m_pocCRA, m_associatedIRAPType, m_cListPic );
+      // Set reference list
+      pcSlice->setRefPicList( m_cListPic, true );
+#else
+      if (pcSlice->getSliceType() != I_SLICE )
+      {
+        if( m_decProcPocAndRps == ANNEX_F )
+        {
+          pcSlice->f834decProcForRefPicListConst();
+        }
+        else if ( m_decProcPocAndRps == CLAUSE_8 )
+        {
+          pcSlice->cl834DecProcForRefPicListConst();
+        }
+        else
+        {
+          assert( false ); 
+        }
+      }
 #if NH_3D_NBDV
-    pcSlice->setDefaultRefView();
+      pcSlice->setDefaultRefView();
 #endif
 #if NH_3D_ARP
-    pcSlice->setARPStepNum(m_ivPicLists);
-#endif
-#else
-    pcSlice->setRefPicList( m_cListPic, true );
-#endif
-
-#if NH_3D
-    pcSlice->checkInCompPredRefLayers(); 
-#if NH_3D_IV_MERGE
-#if H_3D_FCO
-    //assert( !getIsDepth() );
-#else
-    assert( !getIsDepth() || ( pcSlice->getTexturePic() != 0 ) );
-#endif
-#endif    
-#endif
-#if NH_MV
-    if( m_layerId > 0 && !pcSlice->isIntra() && pcSlice->getEnableTMVPFlag() )
-    {
-      TComPic* refPic = pcSlice->getRefPic(RefPicList(1 - pcSlice->getColFromL0Flag()), pcSlice->getColRefIdx());
-
-      assert ( refPic );
-      assert ( refPic->getPicSym()->getSlice(0)->getAvailableForTMVPRefFlag() == true );
-    }
-#endif
-
-    // For generalized B
-    // note: maybe not existed case (always L0 is copied to L1 if L1 is empty)
-    if (pcSlice->isInterB() && pcSlice->getNumRefIdx(REF_PIC_LIST_1) == 0)
-    {
-      Int iNumRefIdx = pcSlice->getNumRefIdx(REF_PIC_LIST_0);
-      pcSlice->setNumRefIdx        ( REF_PIC_LIST_1, iNumRefIdx );
-
-      for (Int iRefIdx = 0; iRefIdx < iNumRefIdx; iRefIdx++)
-      {
-        pcSlice->setRefPic(pcSlice->getRefPic(REF_PIC_LIST_0, iRefIdx), REF_PIC_LIST_1, iRefIdx);
-      }
-    }
-    if (!pcSlice->isIntra())
-    {
-      Bool bLowDelay = true;
-      Int  iCurrPOC  = pcSlice->getPOC();
-      Int iRefIdx = 0;
-
-      for (iRefIdx = 0; iRefIdx < pcSlice->getNumRefIdx(REF_PIC_LIST_0) && bLowDelay; iRefIdx++)
-      {
-        if ( pcSlice->getRefPic(REF_PIC_LIST_0, iRefIdx)->getPOC() > iCurrPOC )
+      pcSlice->setPocsInCurrRPSs(); 
+      pcSlice->setARPStepNum(m_dpb);
+#endif     
+#endif
+
+      // For generalized B
+      // note: maybe not existed case (always L0 is copied to L1 if L1 is empty)
+      if (pcSlice->isInterB() && pcSlice->getNumRefIdx(REF_PIC_LIST_1) == 0)
+      {
+        Int iNumRefIdx = pcSlice->getNumRefIdx(REF_PIC_LIST_0);
+        pcSlice->setNumRefIdx        ( REF_PIC_LIST_1, iNumRefIdx );
+
+        for (Int iRefIdx = 0; iRefIdx < iNumRefIdx; iRefIdx++)
         {
-          bLowDelay = false;
+          pcSlice->setRefPic(pcSlice->getRefPic(REF_PIC_LIST_0, iRefIdx), REF_PIC_LIST_1, iRefIdx);
         }
       }
-      if (pcSlice->isInterB())
-      {
-        for (iRefIdx = 0; iRefIdx < pcSlice->getNumRefIdx(REF_PIC_LIST_1) && bLowDelay; iRefIdx++)
+      if (!pcSlice->isIntra())
+      {
+        Bool bLowDelay = true;
+        Int  iCurrPOC  = pcSlice->getPOC();
+        Int iRefIdx = 0;
+
+        for (iRefIdx = 0; iRefIdx < pcSlice->getNumRefIdx(REF_PIC_LIST_0) && bLowDelay; iRefIdx++)
         {
-          if ( pcSlice->getRefPic(REF_PIC_LIST_1, iRefIdx)->getPOC() > iCurrPOC )
+          if ( pcSlice->getRefPic(REF_PIC_LIST_0, iRefIdx)->getPOC() > iCurrPOC )
           {
             bLowDelay = false;
           }
         }
-      }
-
-      pcSlice->setCheckLDC(bLowDelay);
-    }
-
-    //---------------
-    pcSlice->setRefPOCList();
+        if (pcSlice->isInterB())
+        {
+          for (iRefIdx = 0; iRefIdx < pcSlice->getNumRefIdx(REF_PIC_LIST_1) && bLowDelay; iRefIdx++)
+          {
+            if ( pcSlice->getRefPic(REF_PIC_LIST_1, iRefIdx)->getPOC() > iCurrPOC )
+            {
+              bLowDelay = false;
+            }
+          }
+        }
+
+        pcSlice->setCheckLDC(bLowDelay);
+      }
+
+      //---------------
+      pcSlice->setRefPOCList();
 #if  NH_3D_TMVP
-    if(pcSlice->getLayerId())
-    {
-      pcSlice->generateAlterRefforTMVP();
-    }
-#endif
-  }
-
-  m_pcPic->setCurrSliceIdx(m_uiSliceIdx);
-  if(pcSlice->getSPS()->getScalingListFlag())
-  {
-    TComScalingList scalingList;
-    if(pcSlice->getPPS()->getScalingListPresentFlag())
-    {
-      scalingList = pcSlice->getPPS()->getScalingList();
-    }
-    else if (pcSlice->getSPS()->getScalingListPresentFlag())
-    {
-      scalingList = pcSlice->getSPS()->getScalingList();
+      if(pcSlice->getLayerId())
+      {
+        pcSlice->generateAlterRefforTMVP();
+      }
+#endif
+    }
+
+    m_pcPic->setCurrSliceIdx(m_uiSliceIdx);
+    if(pcSlice->getSPS()->getScalingListFlag())
+    {
+      TComScalingList scalingList;
+      if(pcSlice->getPPS()->getScalingListPresentFlag())
+      {
+        scalingList = pcSlice->getPPS()->getScalingList();
+      }
+      else if (pcSlice->getSPS()->getScalingListPresentFlag())
+      {
+        scalingList = pcSlice->getSPS()->getScalingList();
+      }
+      else
+      {
+        scalingList.setDefaultScalingList();
+      }
+      m_cTrQuant.setScalingListDec(scalingList);
+      m_cTrQuant.setUseScalingList(true);
     }
     else
     {
-      scalingList.setDefaultScalingList();
-    }
-    m_cTrQuant.setScalingListDec(scalingList);
-    m_cTrQuant.setUseScalingList(true);
-  }
-  else
-  {
-    const Int maxLog2TrDynamicRange[MAX_NUM_CHANNEL_TYPE] =
-    {
+      const Int maxLog2TrDynamicRange[MAX_NUM_CHANNEL_TYPE] =
+      {
         pcSlice->getSPS()->getMaxLog2TrDynamicRange(CHANNEL_TYPE_LUMA),
         pcSlice->getSPS()->getMaxLog2TrDynamicRange(CHANNEL_TYPE_CHROMA)
-    };
-    m_cTrQuant.setFlatScalingList(maxLog2TrDynamicRange, pcSlice->getSPS()->getBitDepths());
-    m_cTrQuant.setUseScalingList(false);
-  }
-
-#if !NH_3D_FIX_TICKET_101
-#if NH_3D_IV_MERGE
-#if H_3D_FCO
-  if( !pcSlice->getIsDepth() && m_pcCamParsCollector )
+      };
+      m_cTrQuant.setFlatScalingList(maxLog2TrDynamicRange, pcSlice->getSPS()->getBitDepths());
+      m_cTrQuant.setUseScalingList(false);
+    }
+
+#if NH_3D
+    if ( decProcAnnexI() )
+    {
+      pcSlice->checkInCompPredRefLayers(); 
+    }
+#endif
+
+    //  Decode a picture
+    m_cGopDecoder.decompressSlice(&(nalu.getBitstream()), m_pcPic);
+
+#if NH_3D
+    if( m_pcCamParsCollector )
+    {
+      m_pcCamParsCollector->setSlice( pcSlice );
+    }
+#endif
+
+#if !NH_MV
+    m_bFirstSliceInPicture = false;
 #else
-  if( pcSlice->getIsDepth() && m_pcCamParsCollector )
-#endif
-  {
-    m_pcCamParsCollector->copyCamParamForSlice( pcSlice );
-  }
-#endif
-#endif
-  //  Decode a picture
-  m_cGopDecoder.decompressSlice(&(nalu.getBitstream()), m_pcPic);
-
-#if NH_3D
-  if( m_pcCamParsCollector )
-  {
-    m_pcCamParsCollector->setSlice( pcSlice );
-  }
-#endif
-
-  m_bFirstSliceInPicture = false;
+  }
+#endif
   m_uiSliceIdx++;
 
+#if !NH_MV
   return false;
-}
+#endif
+}
+
 
 Void TDecTop::xDecodeVPS(const std::vector<UChar> &naluData)
@@ -1333,5 +1264,5 @@
 
 #if NH_MV
-Bool TDecTop::decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, Bool newLayerFlag, Bool& sliceSkippedFlag )
+Bool TDecTop::decodeNonVclNalu(InputNALUnit& nalu )
 #else
 Bool TDecTop::decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay)
@@ -1354,7 +1285,4 @@
     case NAL_UNIT_VPS:
       xDecodeVPS(nalu.getBitstream().getFifo());
-#if NH_MV
-      m_isLastNALWasEos = false;
-#endif
       return false;
 
@@ -1373,10 +1301,4 @@
 
     case NAL_UNIT_SUFFIX_SEI:
-#if NH_MV
-      if ( nalu.m_nalUnitType == NAL_UNIT_SUFFIX_SEI )
-      {
-        assert( m_isLastNALWasEos == false );
-      }
-#endif
       if (m_pcPic)
       {
@@ -1410,17 +1332,6 @@
     case NAL_UNIT_CODED_SLICE_RASL_R:
 #if NH_MV
-      if (nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_TRAIL_R || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_TRAIL_N ||
-          nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_TSA_R || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_TSA_N ||
-          nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_STSA_R || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_STSA_N ||
-          nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_RADL_R || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_RADL_N ||
-          nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_RASL_R || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_RASL_N )
-      {
-        assert( m_isLastNALWasEos == false );
-      }
-      else
-      {
-        m_isLastNALWasEos = false;
-      }
-      return xDecodeSlice(nalu, iSkipFrame, iPOCLastDisplay, newLayerFlag, sliceSkippedFlag );
+      assert( false ); 
+      return 1; 
 #else
       return xDecodeSlice(nalu, iSkipFrame, iPOCLastDisplay);
